#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<fstream>
#include<iostream>
//Questo script è stato realizzato per risolvere equazioni differenziali parziali ellittiche. 

double **allocate2(double **w,int n,int m)
{
        int i;
        w=(double **)calloc(n,sizeof(double *));
        for(i=0;i<=n;i++)
        {
                w[i]=(double *)calloc(m,sizeof(double));
        }
	return w;
}

double f(double x,double y)
{
  double fun;
  fun= x*exp(y);
  return fun;
}
double g(double x,double y)
{
  if(x==0 && y>=0 && y<=1)
     return 0;
  else if(x==2 && y>=0 && y<=1)
    return 2*exp(y);
  else if(x>=0 && x<=2 && y==0)
    return x;
  else if(x>=0 && x<=2 && y==1)
    return exp(1)*x;
  else return 0;
  
}

void writeout2(char *filename,double *x,double *y,double **p,int N,int M)
{
    int i,j;
    FILE *fptr;
    fptr=fopen(filename,"w");
    for(i=1;i<N;i++)
    {
        for(j=1;j<M;j++)
            fprintf(fptr,"%lf \t %lf \t %lf \n",x[i],y[j],p[i][j]);
    }
    fclose(fptr);
}

using namespace std;
int main()
{
  int m,n,i,j,N;
  double a=0,b=0,c=0,d=0,TOL,h,k,lam,mu,l,NORM,z; /*N=maximum number of iterations*/
  double *x,*y,**w=NULL;
  char data[20]="PoissonData.dat";

  while(a>=b && c>=d)
    {
      cout << "Insert endpoints a,b,c,d:"<<endl;
      cout << "a=";
      cin >> a;
      cout << "b=";
      cin >> b;
      cout << "c=";
      cin >> c;
      cout << "d=";
      cin >> d;
      }
  cout << "Insert the integers m and n" << endl;
  cin >> m >> n;
  cout << "Insert the tolerance TOL" << endl;
  cin >> TOL;
  cout << "Insert the maximum number of iterations N" << endl;
  cin >> N;
  
  h=(b-a)/n;
  k=(d-c)/m;
  x=(double*)calloc(n,sizeof(double));
  y=(double*)calloc(m,sizeof(double));
  w=allocate2(w,n,m);    
    
  for(i=1;i<n;i++)
      x[i]=a+i*h;
  for(j=1;j<m;j++)
    y[j]=c+j*k;
  
   for(i=1;i<n;i++)
      for(j=1;j<m;j++)
	w[i][j]=0;

   lam=pow(h,2)/pow(k,2);
   mu=2*(1+lam);
   l=1;
   
   while(l<=N)
     {
       z=(-pow(h,2)*f(x[1],y[m-1])+g(a,y[m-1])+lam*g(x[1],d)+lam*w[1][m-2]+w[2][m-1])/mu;
       NORM=fabs(z-w[1][m-1]);
       w[1][m-1]=z;
       for(i=2;i<(n-1);i++)
	 {
	   z=(-pow(h,2)*f(x[i],y[m-1])+lam*g(x[i],d)+lam*w[i][m-2]+w[i-1][m-1]+w[i+1][m-1])/mu;
	   if(fabs(w[i][m-1]-z)>NORM)
	     NORM=fabs(w[i][m-1]-z);
	   w[i][m-1]=z;
	 }
       z=(-pow(h,2)*f(x[n-1],y[m-1])+g(b,y[m-1])+lam*g(x[n-1],d)+lam*w[n-1][m-2]+w[n-2][m-1])/mu;
       if(fabs(w[n-1][m-1]-z)>NORM)
	 NORM=fabs(w[n-1][m-1]-z);
       w[n-1][m-1]=z;
       for(j=m-2;j>1;j--)
	 {
	   z=(-pow(h,2)*f(x[1],y[j])+g(a,y[j])+lam*w[1][j+1]+lam*w[1][j-1]+w[2][j])/mu;
	   if(fabs(w[1][j]-z)>NORM)
	     NORM=fabs(w[1][j]-z);
	   w[1][j]=z;
	   for(i=2;i<n-1;i++)
	     {
	       z=(-pow(h,2)*f(x[i],y[j])+w[i-1][j]+lam*w[i][j+1]+w[i+1][j]+lam*w[i][j-1])/mu;
		   if(fabs(w[i][j]-z)>NORM)
		     NORM=fabs(w[i][j]-z);
		   w[i][j]=z;
	     }
	   z=(-pow(h,2)*f(x[n-1],y[j])+g(b,y[j])+w[n-2][j]+lam*w[n-1][j+1]+lam*w[n-1][j-1])/mu;
	   if(fabs(w[n-1][j]-z)>NORM)
	     NORM=fabs(w[n-1][j]-z);
	   w[n-1][j]=z;
	 }
       z=(-pow(h,2)*f(x[1],y[1])+g(a,y[1])+lam*g(x[1],c)+lam*w[1][2]+w[2][1])/mu;
       if(fabs(w[1][1]-z)>NORM)
	 NORM=fabs(w[1][1]-z);
       w[1][1]=z;
       for(i=2;i<n-1;i++)
	 {   
	   z=(-pow(h,2)*f(x[i],y[1])+lam*g(x[i],c)+w[i-1][1]+lam*w[i][2]+w[i+1][1])/mu;
	   if(fabs(w[i][1]-z)>NORM)
	     NORM=fabs(w[i][1]-z);
	   w[i][1]=z;
	 }
       z=(-pow(h,2)*f(x[n-1],y[1])+g(b,y[1])+lam*g(x[n-1],c)+w[n-2][1]+lam*w[n-1][2])/mu;
       if(fabs(w[n-1][1]-z)>NORM)
	 NORM=fabs(w[i][1]-z);
       w[n-1][1]=z;
       if(NORM<=TOL)
	 {
	   cout<<"i\t"<<"j\t"<<"x[i]\t"<<"\t"<<"y[j]\t"<<"\t"<<"w[i][j]"<<endl;
	   for(i=1;i<n;i++)
	     for(j=1;j<m;j++)
	       {
		 cout<<i<<"\t"<<j<<"\t"<<x[i]<<"\t\t"<<y[j]<<"\t\t"<<w[i][j]<<endl;
	       }
         writeout2(data,x,y,w,n,m);
	   cout<<"The procedure was successful";
	   return 0;
	 }
       l=l+1;
     }
   cout<< "Maximum number of iterarions exceeded"<<endl;
   cout<<"The procedure was unsuccessful";
   return 0;
}
