
#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include<fstream>
#include<iostream>
#define Pi 3.14159

//Questo script è stato realizzato per risolvere equazioni differenziali parziali praboliche. In particolare risolve l'equazione del calore numericamente con vari metodi numerici che di seguito verranno specificati.

double **allocate2(double **w, int n, int m)
{
    int i;
    w=(double **)calloc(n,sizeof(double *));
    for(i=0;i<=n;i++)
    {
        w[i]=(double *)calloc(m,sizeof(double));
    }
    return w;
}


double f(double x)
{
    double g;
    g=pow(x,2)-2*pow(x,3)+sqrt(x);
    return g;
}

void writeout2(char *filename,double *x,double *t,double **p,int N,int M)
{
    int i,j;
    FILE *fptr;
    fptr=fopen(filename,"w");
    for(j=0;j<=M;j++)
    {
        for(i=0;i<=N;i++)
            fprintf(fptr,"%lf \t %lf \t %lf \n",x[i],t[j],p[i][j]);
    }
    fclose(fptr);
}

using namespace std;
int main()
{
    remove("HeatData.dat");
    remove("HeatDataRichardson.dat");
    remove("HeatDataDuFort.dat");
    
    
    int m,i,j,N;                        /*N=maximum number of iterations*/
    double L=0,T=0,alpha=0,h,k,lam,l=0;
    double *t,*x,**w=NULL;
    char data[20]="HeatData.dat";
    char data1[40]="HeatDataRichardson.dat";
    char data2[40]="HeatDataDuFort.dat";
    
    while(L<=0 && T<=0)
    {
        cout << "Insert endpoint L, the maximum time T, the constant alpha:"<<endl;
        cout << "L=";
        cin >> L;
        cout << "T=";
        cin >> T;
        cout << "alpha=";
        cin >> alpha;
    }
    cout << "Insert the integer m for the division of the time intervall" << endl;
    cin >> m;
    cout << "Insert the integer N for the division of the spatial intervall" << endl;
    cin >> N;
    
    t=(double*)calloc(m+1,sizeof(double));
    x=(double*)calloc(N+1,sizeof(double));
    w=allocate2(w,N+1,m+1);
    
    h=L/N;
    k=T/m;
    lam=alpha*k/pow(h,2);
    
    /* Algoritmo FTCS */
     
     
    for(i=0;i<=m;i++)
    {
        w[0][i]=0;
        w[N][i]=0;
    }
    
    for(j=0;j<=N;j++)
        w[j][0]=f(j*h);
        
    t[0]=0;
    t[m]=T;
    x[0]=0;
    x[N]=L;
    
    for(j=0;j<m;j++)
    {
        t[j]=j*k;
        
        for(i=1;i<N;i++)
        {
            x[i]=i*h;
            w[i][j+1]=w[i][j]+lam*(w[i+1][j]-2*w[i][j]+w[i-1][j]);
        }
        
    }
    cout << "I risultati ottenuti con il metodo FTCS si trovano nel file HeatData.dat" << endl;
    writeout2(data,x,t,w,N,m);
    
    /* Algoritmo di Richardson */
    
    for(i=0;i<=m;i++)
    {
        w[0][i]=0;
        w[N][i]=0;
    }
    
    for(j=0;j<=N;j++)
        w[j][0]=f(j*h);
    
    t[0]=0;
    t[m]=T;
    x[0]=0;
    x[N]=L;
    
    for(i=1;i<N;i++)
        w[i][1]=w[i][0]+lam*(w[i+1][0]-2*w[i][0]+w[i-1][0]);
    
    for(j=1;j<m;j++)
        for(i=1;i<N;i++)
            w[i][j+1]=w[i][j-1]+2*lam*(w[i+1][j]-2*w[i][j]+w[i-1][j]);
   
    for(j=0;j<m;j++)
    {
        t[j]=j*k;
    }
    for(i=1;i<N;i++)
    {
        x[i]=i*h;
    }
    
    cout << "I risultati ottenuti con il metodo di Richardson si trovano nel file HeatDataRichardson.dat" << endl;
    writeout2(data1,x,t,w,N,m);

    /* Algoritmo di DuFort-Frankel */
    
    for(i=0;i<=m;i++)
    {
        w[0][i]=0;
        w[N][i]=0;
    }
    
    for(j=0;j<=N;j++)
    {
        l=j*h;
        w[j][0]=f(l);
    }
    t[0]=0;
    t[m]=T;
    x[0]=0;
    x[N]=L;
    
    for(i=1;i<N;i++)
        w[i][1]=w[i][0]+lam*(w[i+1][0]-2*w[i][0]+w[i-1][0]);
    
    for(j=1;j<m;j++)
        for(i=1;i<N;i++)
            w[i][j+1]=(1-2*lam)/(1+2*lam)*w[i][j-1]+2*lam/(1+2*lam)*(w[i+1][j]+w[i-1][j]);
    
    for(j=0;j<m;j++)
    {
        t[j]=j*k;
    }
    for(i=1;i<N;i++)
    {
        x[i]=i*h;
    }
    
    cout << "I risultati ottenuri con il metodo di DuFort-Frankel si trovano nel file HeatDataDuFort.dat" << endl;
    writeout2(data2,x,t,w,N,m);
    
    /*system("/Applications/Mathematica.app/Contents/MacOS/Mathematica /Users/Matteo/Desktop/Esame_Lab_Fis_Comp/Mathematica/Mathematica_Project.nb");
    */

    return 0;
}

